/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008-2011 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

/**
 * UGENE - Integrated Bioinformatics Tools.
 * Copyright (C) 2008-2011 UniPro <ugene@unipro.ru>
 * http://ugene.unipro.ru
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 */


#include <U2Core/AppContext.h>
#include <U2Misc/DialogUtils.h>

#include <QtGui/QFileDialog>
#include <QtGui/QMessageBox>

#include "UIndexExportToNewFileDialogImpl.h"

namespace U2 {

UIndexExportToNewFileDialogImpl::UIndexExportToNewFileDialogImpl() {
    setupUi( this );
    
    okButton->setDefault( true );
    connect( exportFileOpenButton, SIGNAL( clicked() ), SLOT( sl_openExportFile() ) );
}

UIndexExportToNewFileDialogModel UIndexExportToNewFileDialogImpl::getModel() const {
    return model;
}

void UIndexExportToNewFileDialogImpl::sl_openExportFile() {
    LastOpenDirHelper h;
    h.url = QFileDialog::getSaveFileName( this, tr( "Select file to export" ), h.dir );
    if (!h.url.isEmpty()) {
        exportFileEdit->setText(h.url);
    }
}

void UIndexExportToNewFileDialogImpl::accept() {
    model.exportFilename = exportFileEdit->text();
    model.gzipExported = ( Qt::Checked == gzipExportedCheck->checkState() );
    if (model.exportFilename.isEmpty()) {
        QMessageBox::critical(this, tr("Error"), tr("Illegal file name"));
        exportFileEdit->setFocus();
        return;
    }
    QDialog::accept();
}

} // U2
